import { DialogSOP } from '../../libappsop/dialogsop';
import { EditFieldSOP } from '../../libappsop/editfieldsop';
import { DropDownListSOP } from '../../libappsop/dropdownlistsop';

export interface DialogBookmarkFields {
  Name?: string;
  Folder?: string;
}

export class DialogBookmark extends DialogSOP<DialogBookmarkFields> {
  public static readonly title = 'Bookmark';
  public efName = new EditFieldSOP('EditFieldName');
  public ddlFolder = new DropDownListSOP('DropDownBookmarkFolder');

  public constructor() {
    super('DialogCreateEditBookmark', 'btnOK');

    // Set UI element mapping to pair the UI name to the UI element for use in DialogSOP to find the UI object to set value or verify value
    // This prevents each new Dialog to duplicate code just to set/verify UI element value
    this._uiMap.set('Name', this.efName);
    this._uiMap.set('Folder', this.ddlFolder);
  }
}

/**
 * Expected tooltip for OK button when disabled.
 */
export const okButtonDisabledTooltip = {
  sameBookmarkName: (): string => 'Bookmark or folder must be unique by name.',
};
